    REM *******************
    REM *** TRACKER 6.0 ***
    REM *******************
    REM
    REM This programs displays the locations of various features
    REM on the southern hemisphere of Jupiter.
    REM Dan Bruton (astro@sfasu.edu)
    REM
    DEFDBL A-Z
    PI = 3.141593327#
    P = PI / 180
    P1 = 0: P2 = 1: 'Video Pages
    ANIM = 0
    DIM NMF$(40), LATF(100), LONF(100), SZF(100), COLF(100), DTF$(100)
    DIM NM$(20), LAT(20), LON(20), SZ(20), DT$(20)
    DIM DA(20), HO(20), MN(20), ZZ$(10)
    DIM TH(from - 1 TO 500), PH(from - 1 TO 1000)
    DIM XP(from - 1 TO 1, from - 1 TO 1), YP(from - 1 TO 1, from - 1 TO 1)
    LAB1 = 0
    LAB2 = 1
    NS1 = 1
    NS2 = -1
    ZONE = 0
    REM ********************* Calculate Phi's ****************************
    FOR J = 0 TO 36
    PH(J) = 2 * PI * J / 36
    NEXT J
    REM ********************* Calculate Theta's **************************
    FOR I = 9 TO 18
    TH(I) = PI * I / 18
    NEXT I
    REM ******************** PROGRAM CONTROL *******************************
    GOSUB 400: '  Print Program Info and get Time Zone
    GOSUB 500: '  Read Feature and Impact Data
101 CHG = 0
    GOSUB 1200: ' Get Date and Time
    GOSUB 1220: ' Universal Date and Time & Correct Time
    GOSUB 100: '  Find Longitude of Central Meridian (MER)
    GOSUB 300: '  Draw Jupiter with Features and Impact Sites
111 GOSUB 1200: ' Get Date and Time
    GOSUB 1220: ' Universal Date and Time
    SCREEN 9, , P1, P1
    GOSUB 350
110 Z$ = INKEY$
    IF Z$ = "A" OR Z$ = "a" THEN GOSUB 1500
    IF Z$ = "x" OR Z$ = "X" THEN GOTO 9999
    IF Z$ = "?" THEN GOSUB 1000: GOSUB 300
    IF Z$ = "C" OR Z$ = "c" THEN GOTO 101
    IF Z$ = "D" OR Z$ = "d" THEN NSEC = 0: GOSUB 2000
    IF Z$ = "I" OR Z$ = "i" THEN GOSUB 2600
    IF Z$ = "L" OR Z$ = "l" THEN SWAP LAB1, LAB2: GOSUB 300
    IF Z$ = "N" OR Z$ = "n" THEN SWAP NS1, NS2: CLS : GOSUB 300
    IF Z$ = "G" OR Z$ = "g" THEN GOSUB 320
    IF Z$ = "M" THEN NMIN = NMIN + 1: CHG = 1: NSEC = 0: GOSUB 350
    IF Z$ = "m" THEN NMIN = NMIN - 1: CHG = 1: NSEC = 0: GOSUB 350
    IF Z$ = "T" THEN NMIN = NMIN + 10: CHG = 1: NSEC = 0: GOSUB 350
    IF Z$ = "t" THEN NMIN = NMIN - 10: CHG = 1: NSEC = 0: GOSUB 350
    IF Z$ = "H" THEN LHOUR = LHOUR + 1: CHG = 1: NSEC = 0: GOSUB 350
    IF Z$ = "h" THEN LHOUR = LHOUR - 1: CHG = 1: NSEC = 0: GOSUB 350
    IF LHOUR <> LASTH OR NMIN <> LASTM THEN GOSUB 2500
    LASTH = LHOUR: LASTM = NMIN
    IF CHG = 0 THEN GOTO 111 ELSE GOTO 110

1500 REM ******************** Animate ***************************************
     CHG = 1
     SCREEN 9, , P1, P1
     LOCATE 2, 30
     PRINT "                                                  "
     LOCATE 4, 30
     PRINT "                                                  "
     LOCATE 6, 30
     PRINT "                                                  "
     LOCATE 8, 30
     PRINT "                                                  "
     LOCATE 10, 30
     PRINT "                                                  "
     LOCATE 5, 40
     PRINT "Enter the time step size"
     LOCATE 6, 40
     INPUT "in minutes (Default -> 1): ", STP
     IF STP = 0 THEN STP = 1
     NSEC = 0
     ANIM = 1
1501 Z$ = INKEY$
     IF Z$ <> "" THEN GOTO 1502
     NMIN = NMIN + STP
     GOSUB 1220: GOSUB 100: GOSUB 300
     GOTO 1501
1502 ANIM = 0
     RETURN

2000 REM **************** Change Date and Time Manually *********************
     SCREEN 9, , P1, P1
     CHG = 1
     LOCATE 2, 30
     PRINT "                                                  "
     LOCATE 4, 30
     PRINT "                                                  "
     LOCATE 6, 30
     PRINT "                                                  "
     LOCATE 8, 30
     PRINT "                                                  "
     LOCATE 10, 30
     PRINT "                                                  "
     LOCATE 12, 30
     PRINT "                                                  "
     LOCATE 3, 44
     PRINT "Enter Universal Date"
     LOCATE 5, 40
     INPUT "     Year (YYYY) : ", NYEAR
     LOCATE 6, 40
     INPUT "      Month (MM) : ", NMONTH
     LOCATE 7, 40
     INPUT "        Day (DD) : ", NDAY
     LOCATE 3, 40
     PRINT "                                   "
     LOCATE 5, 40
     PRINT "                                   "
     LOCATE 6, 40
     PRINT "                                   "
     LOCATE 7, 40
     PRINT "                                   "
     LOCATE 3, 40
     PRINT "Enter Universal Time"
     LOCATE 5, 40
     INPUT "          Hour : ", NHOUR
     LOCATE 6, 40
     INPUT "        Minute : ", NMIN
     LHOUR = NHOUR - DHOUR
     LDAY = NDAY
     LYEAR = NYEAR
     LMONTH = NMONTH
     GOSUB 2500
     RETURN

2500 REM ************ Update Screen after Changing Date or Time ***********
     GOSUB 1220: GOSUB 100: GOSUB 300
     RETURN

2600 REM *************** Change date and time to first impact *************
     CHG = 1
     LYEAR = 1994
     LMONTH = 7
     LDAY = DA(1)
     LHOUR = HO(1) - DHOUR
     NMIN = MN(1)
     NSEC = 0
     GOSUB 2500
     RETURN

300 REM ********************* DRAW JUPITER ***************************
    SWAP P1, P2
    SCREEN 9, , P1, P2
    CLS
    GOSUB 350
    PALETTE 4, 20: 'Red Clouds
    LOCATE 43, 1: PRINT "0"; CHR$(248);
    LOCATE 30, 1: PRINT " 30"; CHR$(248);
    LOCATE 20, 1: PRINT " 60"; CHR$(248);
    LOCATE 30, 1: IF NS1 = 1 THEN PRINT "-" ELSE PRINT "+"
    LOCATE 20, 1: IF NS1 = 1 THEN PRINT "-" ELSE PRINT "+"

    LINE (55, 233)-(35, 233), 15: ' -30 degree line
    LINE (165, 153)-(35, 153), 15: ' -60 degree line
    CIRCLE (320, 342), 300, 4, 0, PI: 'Draw Jupiter`s Surface
    LINE (20, 342)-(620, 342), 4
    PAINT (320, 335), 7, 4

    YPOS = 342 + (300 * SIN(-7.4 * P)) / 1.38:      'SEB North -7.4 Degrees
    XX1 = SQR(90000 - ((342 - YPOS) * 1.38) ^ 2)
    LINE (320 - XX1 - 1, YPOS)-(320 + XX1 + 1, YPOS), 4
    YPOS = 342 + (300 * SIN(-22.2 * P)) / 1.38:     'SEB South
    XX1 = SQR(90000 - ((342 - YPOS) * 1.38) ^ 2)
    LINE (320 - XX1 - 1, YPOS)-(320 + XX1 + 1, YPOS), 4
    PAINT (320, YPOS + 2), 4, 4:                     'SEB
   
    YPOS = 342 + (300 * SIN(-29 * P)) / 1.38:      'STB North
    XX1 = SQR(90000 - ((342 - YPOS) * 1.38) ^ 2)
    LINE (320 - XX1 - 1, YPOS)-(320 + XX1 + 1, YPOS), 4
    YPOS = 342 + (300 * SIN(-36.7 * P)) / 1.38:     'STB South
    XX1 = SQR(90000 - ((342 - YPOS) * 1.38) ^ 2)
    LINE (320 - XX1 - 1, YPOS)-(320 + XX1 + 1, YPOS), 4
    PAINT (320, YPOS + 2), 4, 4:                     'STB
   
    YPOS = 342 + (300 * SIN(-40.7 * P)) / 1.38:      'SSTB North
    XX1 = SQR(90000 - ((342 - YPOS) * 1.38) ^ 2)
    LINE (320 - XX1 - 1, YPOS)-(320 + XX1 + 1, YPOS), 4
    YPOS = 342 + (300 * SIN(-41.7 * P)) / 1.38:     'SSTB South
    XX1 = SQR(90000 - ((342 - YPOS) * 1.38) ^ 2)
    LINE (320 - XX1 - 1, YPOS)-(320 + XX1 + 1, YPOS), 4
    PAINT (320, YPOS + 1), 4, 4:                     'SSTB
  
    FOR II = 125 TO 190 STEP 2
    XX1 = SQR(90000 - ((342 - II) * 1.38) ^ 2)
    LINE (320 - XX1, II)-(320 + XX1, II), 4:       'SPR
    NEXT II
    IF NS1 = -1 THEN GOTO 10
    REM *********************** Draw Red Spot **************************
    DIFF = LONF(1) - MER2
    IF DIFF < -180 THEN DIFF = 360 + DIFF
    IF DIFF > 180 THEN DIFF = DIFF - 360
    IF ABS(DIFF) > 70 THEN GOTO 10
    YPOS = 342 + (300 * SIN(LATF(1) * P)) / 1.38
    XX1 = SQR(90000 - ((342 - YPOS) * 1.38) ^ 2)
    XPOS = 320 + (XX1 * SIN(DIFF * P))
    CIRCLE (XPOS, YPOS), SZF(1) * COS(DIFF * P), 4, , , .4 / COS(DIFF * P): 'RED
    PAINT (XPOS, YPOS - 3), 4, 4: 'RED
    CIRCLE (XPOS, YPOS), SZF(1) * COS(DIFF * P), 7, , , .4 / COS(DIFF * P): 'RED
    IF LAB1 = 1 THEN COLOR 4: LOCATE 34, (XPOS * 80 / 640): PRINT NMF$(1): COLOR 15
10  REM *********************** Draw Spots **************************
    FOR J = 2 TO NNF
    IF (NS1 * LATF(J)) > 0 THEN GOTO 20
    DIFF = LONF(J) - MER2
    IF DIFF < -180 THEN DIFF = 360 + DIFF
    IF DIFF > 180 THEN DIFF = DIFF - 360
    IF ABS(DIFF) > 90 THEN 20
    YPOS = 342 + (NS1 * 300 * SIN(LATF(J) * P)) / 1.38
    XX1 = SQR(90000 - ((342 - YPOS) * 1.38) ^ 2)
    XPOS = 320 + (NS1 * XX1 * SIN(DIFF * P))
    IF XPOS - SZF(J) < 320 - XX1 THEN GOTO 20
    IF XPOS + SZF(J) > 320 + XX1 THEN GOTO 20
    CIRCLE (XPOS, YPOS), SZF(J), COLF(J), , , .55:
    PAINT (XPOS, YPOS), COLF(J), COLF(J):
    CIRCLE (XPOS, YPOS), SZF(J), 4, , , .55:
    IF LAB1 = 1 THEN LOCATE (YPOS * 45 / 350), (XPOS * 80 / 640): PRINT NMF$(J)
20  NEXT J
21  IF NS1 = -1 THEN GOTO 31
    REM ******************* DRAW IMPACT SITES *****************************
    IF (NYEAR < 1994) OR (NYEAR = 1994 AND NMONTH < 7) THEN GOTO 31
    IF (NYEAR <> 1994) THEN GOTO 31
    FOR J = 1 TO NNN
    IF (NYEAR > 1994) OR (NYEAR = 1994 AND NMONTH > 7) THEN GOTO 333
    IF NDAY < DA(J) THEN GOTO 30
    IF NDAY = DA(J) AND NHOUR < HO(J) THEN GOTO 30
    IF NDAY = DA(J) AND NHOUR = HO(J) AND NMIN < MN(J) THEN GOTO 30
333 DIFF = LON(J) - MER2
    IF DIFF < -180 THEN DIFF = 360 + DIFF
    IF DIFF > 180 THEN DIFF = DIFF - 360
    IF ABS(DIFF) > 90 THEN GOTO 30
    YPOS = 342 + (300 * SIN(LAT(J) * P)) / 1.38
    XX1 = SQR(90000 - ((342 - YPOS) * 1.38) ^ 2)
    XPOS = 320 + (XX1 * SIN(DIFF * P))
    CIRCLE (XPOS, YPOS), SZ(J), 9, , , .5
    PAINT (XPOS, YPOS), 0, 9
    CIRCLE (XPOS, YPOS), SZ(J), 0, , , .5
    LOCATE 23, (XPOS * 80 / 640) + 1
    IF LAB1 = 1 THEN PRINT NM$(J)
30  NEXT J
31  REM ***************** TYPE COMMANDS, ETC. *****************************
    LINE (0, 3)-(213, 83), 15, B
    LOCATE 12, 26: PRINT "Longitude of the Central Meridian"
    LOCATE 13, 27: PRINT "System I  System II  System III"
    IF LAB1 = 0 THEN IF NS1 = 1 THEN LOCATE 20, 68: PRINT "Impact Sites"
    IF LAB1 = 0 THEN IF NS1 = 1 THEN LOCATE 21, 68: PRINT "Appear Here"
    IF LAB1 = 0 THEN IF NS1 = 1 THEN LINE (580, 170)-(543, 187), 15
    IF LAB1 = 0 THEN GOTO 32
    COLOR 7: LOCATE 19, 78: IF NS1 = 1 THEN PRINT "SPR" ELSE PRINT "NPR"
    COLOR 7: LOCATE 24, 77: IF NS1 = 1 THEN PRINT "SSTZ" ELSE PRINT "NNTZ"
    COLOR 4: LOCATE 25, 77: IF NS1 = 1 THEN PRINT "SSTB" ELSE PRINT "NNTB"
    COLOR 7: LOCATE 26, 78: IF NS1 = 1 THEN PRINT "STZ" ELSE PRINT "NTZ"
    COLOR 4: LOCATE 29, 78: IF NS1 = 1 THEN PRINT "STB" ELSE PRINT "NTB"
    COLOR 7: LOCATE 32, 77: IF NS1 = 1 THEN PRINT "STrZ" ELSE PRINT "NTrZ"
    COLOR 4: LOCATE 37, 78: IF NS1 = 1 THEN PRINT "SEB" ELSE PRINT "NEB"
    COLOR 7: LOCATE 42, 79: IF NS1 = 1 THEN PRINT "EZ";  ELSE PRINT "EZ";
32  COLOR 15
    LINE (220, 3)-(639, 83), 15, B
    IF ANIM = 1 THEN LOCATE 6, 40: PRINT "Press <Enter> to stop.": GOTO 33
    LOCATE 2, 30
    PRINT "? - Help       M/m - Forward/Reverse by 1 minute"
    LOCATE 4, 30
    PRINT "L - Label      T/t - Forward/Reverse by 10 minutes"
    LOCATE 6, 30
    PRINT "A - Animate    H/h - Forward/Reverse by 1 hour"
    LOCATE 8, 30
    PRINT "C - Current      I - Date and Time of First Impact"
    LOCATE 10, 30
    PRINT "D - Date    G - Grid    N - North/South   X - Exit"
33  LOCATE 3, 3
    PRINT USING "Local Date : ####/##/##"; LYEAR; LMONTH; LDAY
    LOCATE 5, 3
    PRINT USING "Local Time :  ##:##:##"; LHOUR; NMIN; NSEC
    LOCATE 7, 3
    PRINT USING "Univ. Date : ####/##/##"; LYEAR; NMONTH; NDAY
    LOCATE 9, 3
    PRINT USING "Univ. Time :  ##:##:##"; NHOUR; NMIN; NSEC
    LOCATE 14, 28: PRINT USING "###.##!   ###.##!    ###.##!"; MER1; CHR$(248); MER2; CHR$(248); MER3; CHR$(248)
    LINE (320, 113)-(321, 122), 15, BF
    LOCATE 14, 64: PRINT "South": LOCATE 14, 11: PRINT "South"
    IF NS1 = -1 THEN LOCATE 14, 64: PRINT "North": LOCATE 14, 11: PRINT "North"
    LOCATE 15, 62: PRINT "Following": LOCATE 16, 62: PRINT "  Limb"
    LOCATE 15, 9: PRINT "Preceding": LOCATE 16, 9: PRINT "  Limb"
    IF NS1 = -1 THEN LOCATE 15, 9: PRINT "Following": LOCATE 15, 62: PRINT "Preceding"
    SCREEN 9, , P2, P1
    RETURN

320  REM *************************** Draw Grid ***************************
     SCREEN 9, , P1, P1
     FOR I = 10 TO 18
     FOR J = 0 TO 18
     FOR LL = 0 TO 1
     FOR KK = -1 TO 0
     IF LL = 1 AND KK = -1 THEN GOTO 3900
     XP(LL, KK) = 320 - 300 * SIN(TH(I + KK)) * COS(PH(J + LL))
     YP(LL, KK) = 342 + (300 * COS(TH(I + KK)) * 466 / 640)
3900 NEXT KK
     NEXT LL
     LINE (XP(0, 0), YP(0, 0))-(XP(1, 0), YP(1, 0)), 15
     LINE (XP(0, 0), YP(0, 0))-(XP(0, -1), YP(0, -1)), 15
     NEXT J
     NEXT I
     LOCATE 2, 30
     PRINT "                                                  "
     LOCATE 4, 30
     PRINT "                                                  "
     LOCATE 6, 30
     PRINT "                                                  "
     LOCATE 8, 30
     PRINT "                                                  "
     LOCATE 10, 30
     PRINT "                                                  "
     LOCATE 5, 40
     PRINT "Press <Enter> to continue."
     DO WHILE INKEY$ = ""
     LOOP
     GOSUB 300
321  RETURN

350 REM ****************  PRINT TIME AND LONGITUDE *************************
    IF TT$ = TIME$ AND CHG = 0 GOTO 355
    LOCATE 3, 3
    PRINT USING "Local Date : ####/##/##"; NYEAR; LMONTH; LDAY
    LOCATE 5, 3
    PRINT USING "Local Time :  ##:##:##"; LHOUR; NMIN; NSEC
    LOCATE 7, 3
    PRINT USING "Univ. Date : ####/##/##"; NYEAR; NMONTH; NDAY
    LOCATE 9, 3
    PRINT USING "Univ. Time :  ##:##:##"; NHOUR; NMIN; NSEC
    LOCATE 14, 28: PRINT USING "###.##!   ###.##!    ###.##!"; MER1; CHR$(248); MER2; CHR$(248); MER3; CHR$(248)
355 TT$ = TIME$
    RETURN
    
400  REM ********************** Print Info *******************************
     OPEN "tracker6.cfg" FOR INPUT AS #1
     INPUT #1, Z$, DHR
     CLOSE
     SCREEN 9
     WIDTH 80, 25
     LOCATE 5, 23
     PRINT "          T R A C K E R "
     LOCATE 6, 23
     PRINT "           Version 6.0"
     PRINT : PRINT
     PRINT "           This program will display the approximate location of the"
     PRINT
     PRINT "      Great Red Spot and a few othere features on the southern hemisphere"
     PRINT
     PRINT "      of Jupiter as seen from Earth.  The impact sites of the fragments"
     PRINT
     PRINT "      of comet Shoemaker-Levy 9 are also shown if the year is set to 1994."
     PRINT
     PRINT
     PRINT "                   Enter the number of hours to add to local"
     PRINT "                 time to get Universal Time (Default -> "; DHR; ") : ";
     INPUT "", DHOUR$
     IF DHOUR$ = "" THEN DHOUR = DHR: GOTO 1610
     LN = LEN(DHOUR$): DHOUR = 0
     FOR I = 1 TO LN
     DHOR$ = LEFT$(RIGHT$(DHOUR$, I), 1)
     DHOR = ASC(DHOR$) - 48
     IF DHOR = -3 THEN DHOUR = -1 * DHOUR: GOTO 1600
     DHOUR = DHOUR + (DHOR * (10 ^ (I - 1)))
1600 NEXT I
     OPEN "tracker6.cfg" FOR OUTPUT AS #1
     PRINT #1, Z$
     PRINT #1, DHOUR
     CLOSE
1610 SCREEN 9, , 1, 1: CLS
     SCREEN 9, , 0, 0: CLS
     WIDTH 80, 43
     LOCATE 22, 35: PRINT " Working..."
   
     RETURN

1700 REM ********************************************************************
     REM *                                                                  *
     REM *      Find Angle between Sun and Earth as seen from Juipter       *
     REM *                                                                  *
     REM *      See "Practical Astronomy with Your Calculator"              *
     REM *       by Peter Duffett-Smith page 101, Heliocentric Longitudes   *
     REM *                                                                  *
     REM ********************************************************************
     RJ = 5.202451: REA = 1!: REM    Orbit radius of Jup and Earth in AU
     DAYS = JD# - 2444238.5#: REM    Days since Jan 0.0, 1980
     REM Heliocentric Longitudes (below)
     LEA = (360 * DAYS / (365.2422 * 1.00004)) + 98.83354# - 102.596403#
     LEA = LEA + (360# * .016718# * SIN(LEA * P) / PI) + 102.596403#
     REA = REA * (1 - (.016718#) ^ 2) / (1 + .016718# * COS((LEA - 102.596403#) * P))
     LJ = (360# * DAYS / (365.2422# * 11.86224#)) + 146.966365# - 14.0095493#
     LJ = LJ + (360# * .0484658# * SIN(LJ * P) / PI) + 14.0095493#
     RJ = RJ * (1 - (.0484658#) ^ 2) / (1 + .0484658# * COS((LJ - 14.0095493#) * P))
     LEA = ((LEA / 360) - INT(LEA / 360)) * 360
     LJ = ((LJ / 360) - INT(LJ / 360)) * 360
     DIFF = (LJ - LEA) * PI / 180
     REM ALPHA = Angle for Sun Direction (sun arrow)
     ALPHA = 1 + ((RJ / REA) ^ 2) - (2 * (RJ / REA) * COS(DIFF))
     ALPHA = SIN(DIFF) / SQR(ALPHA)
     ALPHA = -1 * ATN(ALPHA / SQR(1 - ALPHA ^ 2)): '            ArcSine
     ALPHA = ALPHA / P
     RETURN


100 REM ********** FIND SYSTEM II LONGITUDE OF CENTRAL MERIDIAN ***********
    REM From July 1993 Issue of Astronomy page 65
    REM MONTH,DAY0,YEAR,MIN -> MER
    DAY0 = DAY + (hour + ZONE) / 24 + (MIN / (60 * 24)) + 1 / 1440
    IF MONTH < 3 THEN year = year - 1: MONTH = MONTH + 12
    A = INT(year / 100): B = 2 - A + INT(A / 4)
    JD = INT(365.25 * year) + INT(30.6001 * (MONTH + 1)) + DAY0 + 1720994.5# + B
    DAYS = JD - 2451545!: CEN = DAYS / 36525!
    RTD = 57.29578
    REM  Calculate orbit of Jupiter
    PP = 11.8567785#: PII = 1.3053 - 4.15 / 3600 * CEN
    PE = 4.839266E-02 - .0001288 * CEN: PA = 5.20336301# + 6.0737E-04 * CEN
    PO = 100.55615# + 1217.17 / 3600 * CEN: PW = 14.75385 + 839.93 / 3600 * CEN
    PL = 34.40438 + 8.308676199999999D-02 * DAYS
    MEAN = PL - PW: Z = MEAN / 360: MEAN = MEAN - 360 * INT(Z)
    TRUE = MEAN + 360 / 3.14159265359# * PE * SIN(MEAN / RTD)
    Z = TRUE / 360: TRUE = TRUE - 360 * INT(Z)
    L = TRUE + PW: R = PA * (1 - PE * PE) / (1 + PE * COS(TRUE / RTD))
    SINPSI = SIN((L - PO) / RTD) * SIN(PII / RTD)
    PSI = ATN(SINPSI / SQR(1 - SINPSI * SINPSI))
    NUM = SIN((L - PO) / RTD) * COS(PII / RTD): DEN = COS((L - PO) / RTD)
    LP = ATN(NUM / DEN) * RTD + PO: IF DEN < 0 THEN LP = LP + 180
    RP = R * COS(PSI)
    REM  Calculate Earth's orbit
    EE = 1.671022E-02 - 3.804E-05 * CEN: EA = 1.00000011# - 5E-08 * CEN
    EW = 102.94719# + 1198.28 / 3600 * CEN: EL = 100.46435# + .9856091 * DAYS
    OBL = 23.43928
    MEANE = EL - EW: Z = MEANE / 360: MEANE = MEANE - 360 * INT(Z)
    TRUEE = MEANE + 360 / 3.14159265359# * EE * SIN(MEANE / RTD)
    Z = TRUEE / 360: TRUEE = TRUEE - 360 * INT(Z)
    LE = TRUEE + EW: RE = EA * (1 - EE * EE) / (1 + EE * COS(TRUEE / RTD))
    LAMB = ATN(RE * SIN((LP - LE) / RTD) / (RP - RE * COS((LP - LE) / RTD))) * RTD + LP
    BETA = ATN(RP * TAN(PSI) * SIN((LAMB - LP) / RTD) / (RE * SIN((LP - LE) / RTD))) * RTD
    REM  Determine Jupiter's position
    NUM = SIN(LAMB / RTD) * COS(OBL / RTD) - TAN(BETA / RTD) * SIN(OBL / RTD)
    DEN = COS(LAMB / RTD)
    RA = ATN(NUM / DEN) * RTD: IF NUM * DEN < 0 THEN RA = RA + 180
    IF NUM < 0 THEN RA = RA + 180
    SINDEC = SIN(BETA / RTD) * COS(OBL / RTD) + COS(BETA / RTD) * SIN(OBL / RTD) * SIN(LAMB / RTD)
    DEC = ATN(SINDEC / SQR(1 - SINDEC * SINDEC)) * RTD
    DSQRD = RE * RE + R * R - 2 * RE * R * COS((L - LE) / RTD): DIST = SQR(DSQRD)
    REM  Compute central meridian on Jupiter at midnight
    REM System I **********************************************************
    A0 = 268.05 - 8.999999E-03 * CEN: D0 = 64.49 + .003 * CEN
    W0 = 67.1 + 877.9 * DAYS: Z = W0 / 360: W0 = W0 - 360 * INT(Z)
    W1 = W0 - 877.9 * .0057755 * DIST: REM Correct for Speed of Light?
    SINB = -SIN(D0 / RTD) * SIN(DEC / RTD) - COS(D0 / RTD) * COS(DEC / RTD) * COS((A0 - RA) / RTD)
    COSB = SQR(1 - SINB * SINB)
    SINK = (SIN(D0 / RTD) * COS(DEC / RTD) * COS((A0 - RA) / RTD) - COS(D0 / RTD) * SIN(DEC / RTD)) / COSB
    COSK = COS(DEC / RTD) * SIN((A0 - RA) / RTD) / COSB
    K = ATN(SINK / COSK) * RTD
    MER1 = W1 - K: IF COSK < 0 THEN MER1 = MER1 + 180
    IF MER1 > 360 THEN MER1 = MER1 - 360
    IF MER1 < 0 THEN MER1 = MER1 + 360
    REM System II ********************************************************
    W0 = 43.3 + 870.27 * DAYS: Z = W0 / 360: W0 = W0 - 360 * INT(Z)
    W1 = W0 - 870.27 * .0057755 * DIST
    SINB = -SIN(D0 / RTD) * SIN(DEC / RTD) - COS(D0 / RTD) * COS(DEC / RTD) * COS((A0 - RA) / RTD)
    COSB = SQR(1 - SINB * SINB)
    SINK = (SIN(D0 / RTD) * COS(DEC / RTD) * COS((A0 - RA) / RTD) - COS(D0 / RTD) * SIN(DEC / RTD)) / COSB
    COSK = COS(DEC / RTD) * SIN((A0 - RA) / RTD) / COSB
    K = ATN(SINK / COSK) * RTD
    MER2 = W1 - K: IF COSK < 0 THEN MER2 = MER2 + 180
    IF MER2 > 360 THEN MER2 = MER2 - 360
    IF MER2 < 0 THEN MER2 = MER2 + 360
    REM System III *********************************************************
    W0 = 284.95 + 870.536 * DAYS: Z = W0 / 360: W0 = W0 - 360 * INT(Z)
    W1 = W0 - 870.536 * .0057755 * DIST
    SINB = -SIN(D0 / RTD) * SIN(DEC / RTD) - COS(D0 / RTD) * COS(DEC / RTD) * COS((A0 - RA) / RTD)
    COSB = SQR(1 - SINB * SINB)
    SINK = (SIN(D0 / RTD) * COS(DEC / RTD) * COS((A0 - RA) / RTD) - COS(D0 / RTD) * SIN(DEC / RTD)) / COSB
    COSK = COS(DEC / RTD) * SIN((A0 - RA) / RTD) / COSB
    K = ATN(SINK / COSK) * RTD
    MER3 = W1 - K: IF COSK < 0 THEN MER3 = MER3 + 180
    IF MER3 > 360 THEN MER3 = MER3 - 360
    IF MER3 < 0 THEN MER3 = MER3 + 360
    RETURN

500 REM ********************* READ DATA *********************************
    OPEN "TRACKER6.DAT" FOR INPUT AS #1
    FOR III = 1 TO 11
    INPUT #1, Z$
    NEXT III
    INPUT #1, NNF, Z$
    FOR I = 1 TO NNF
    INPUT #1, NMF$(I), LATF(I), LONF(I), SZF(I), COLF(I), DTF$(I)
    NEXT I
    INPUT #1, Z$, NNN, Z$
    FOR I = 1 TO NNN
    INPUT #1, NM$(I), DA(I), HO(I), MN(I), LAT(I), LON(I), SZ(I), DT$(I)
    NEXT I
    CLOSE
    RETURN

1000 REM ****************** Print Help ***********************************
     SCREEN 9, , P1, P1
     CLS : WIDTH 80, 25
     PRINT "C O M M A N D S"
     PRINT
     PRINT "                  X - Exit program"
     PRINT
     PRINT "                  D - Change date and time of observation"
     PRINT "                  C - Display current view of Jupiter"
     PRINT
     PRINT "                  L - Toggle the labels for features and impact sites (on/off)"
     PRINT "                  N - Toggle between the North and South Hemisphere of Jupiter"
     PRINT
     PRINT "                  M - Increment time by 1 minute "
     PRINT "                  m - Decrement time by 1 minute "
     PRINT
     PRINT "                  T - Increment time by 10 minutes "
     PRINT "                  t - Decrement time by 10 minutes "
     PRINT
     PRINT "                  H - Increment time by 1 hour "
     PRINT "                  h - Decrement time by 1 hour "
     PRINT
     PRINT "                  I - Change the date and time to that of the first impact"
     PRINT "                  A - Animate the rotation of Jupiter"
     PRINT "                  G - Draw a 10"; CHR$(248); " grid on Jupiter"
     PRINT
     INPUT "Press <Enter>.", asdf$
     CLS
     PRINT "                             FEATURE INFORMATION "
     PRINT
     PRINT "     System I applies to the mean atmospheric equatorial rotation of the"
     PRINT "planet.  System II applies to the mean atmospheric rotation for mid-latitudes"
     PRINT "and is the only longitude system that is really used in this program."
     PRINT "System III applies to the origin of radio emissions on Jupiter."
     PRINT "This program shows the southern hemisphere of Jupiter and shows the"
     PRINT "following features on Jupiter from top to bottom:"
     PRINT
     PRINT "                       SPR - South Polar Region"
     PRINT "                      SSTZ - South South Temperate Zone"
     PRINT "                      SSTB - South South Temperate Belt"
     PRINT "                       STZ - South Temperate Zone"
     PRINT "                       STB - South Temperate Belt"
     PRINT "                      STrZ - South Tropical Zone"
     PRINT "                       SEB - South Equatorial Belt"
     PRINT "                        EZ - Equatorial Zone "
     PRINT
     PRINT "     The Great Red Spot and the white spots FA, BC, and DE are also displayed"
     PRINT "The system II longitudes of these features are variable, so the"
     PRINT "data file TRACKER6.DAT needs to be updated periodically.  Updates will be"
     PRINT "linked at http://astro.phy.sfasu.edu/ in the software area."
     PRINT
     INPUT "Press <Enter>.", asdf$
     CLS
     PRINT
     PRINT "     The times of impact and the current locations of impact sites of the"
     PRINT "fragments of comet Shoemaker-Levy 9 are also contained in TRACKER6.DAT. "
     PRINT "The impact sites of the comet fragments are shown after they rotate past"
     PRINT "the limb of Jupiter and are displayed as dark spots.  The following are"
     PRINT "the impact sites display by TRACKER:"
     PRINT
     INPUT "Press <Enter>.", asdf$
     CLS
     PRINT "              Impact      Impact    Jovicentric   System II       Last "
     PRINT "  Fragment     Date        Time       Latitude    Longitude      Update"
     FOR J = 1 TO NNN
     PRINT USING "    \  \   July ## 1994  ##:## UT      ###.#!      ###.#!      &  "; NM$(J); DA(J); HO(J); MN(J); LAT(J); CHR$(248); LON(J); CHR$(248); DTF$(1)
     NEXT J
     IF NNN > 12 THEN GOTO 1111
     PRINT : PRINT
     PRINT "    Fragments that are not listed above did not create a large impact site"
     PRINT "or a larger impact occured nearby making the impact site difficult to see. "
     PRINT "See TRACKER6.DOC for more information."
     PRINT : PRINT : PRINT
1111 INPUT "                                                             Press <Enter>.", asdf$
     CLS : WIDTH 80, 43
     RETURN
   
1200 REM ********************************************************************
     REM *                                                                  *
     REM *    Determine Time                                                *
     REM *                                                                  *
     REM ********************************************************************
     t$ = LEFT$(DATE$, 1): LMONTH = (ASC(t$) - 48) * 10
     t$ = RIGHT$(LEFT$(DATE$, 2), 1): LMONTH = LMONTH + ASC(t$) - 48
     t$ = RIGHT$(LEFT$(DATE$, 4), 1): LDAY = (ASC(t$) - 48) * 10
     t$ = RIGHT$(LEFT$(DATE$, 5), 1): LDAY = LDAY + ASC(t$) - 48
     t$ = RIGHT$(LEFT$(DATE$, 7), 1): LYEAR = (ASC(t$) - 48) * 1000
     t$ = RIGHT$(LEFT$(DATE$, 8), 1): LYEAR = LYEAR + (ASC(t$) - 48) * 100
     t$ = RIGHT$(LEFT$(DATE$, 9), 1): LYEAR = LYEAR + (ASC(t$) - 48) * 10
     t$ = RIGHT$(LEFT$(DATE$, 10), 1): LYEAR = LYEAR + ASC(t$) - 48
     t$ = (LEFT$(TIME$, 1)): LHOUR = (ASC(t$) - 48) * 10
     t$ = RIGHT$(LEFT$(TIME$, 2), 1): LHOUR = LHOUR + ASC(t$) - 48
     t$ = RIGHT$(LEFT$(TIME$, 4), 1): NMIN = (ASC(t$) - 48) * 10
     t$ = RIGHT$(LEFT$(TIME$, 5), 1): NMIN = NMIN + ASC(t$) - 48
     t$ = RIGHT$(LEFT$(TIME$, 7), 1): NSEC = (ASC(t$) - 48) * 10
     t$ = RIGHT$(LEFT$(TIME$, 8), 1): NSEC = NSEC + ASC(t$) - 48
     RETURN

1220 REM ********************************************************************
     REM *                                                                  *
     REM *  Correct Time after Time Increment                               *
     REM *                                                                  *
     REM ********************************************************************
     IF NSEC >= 60 THEN NSEC = NSEC - 60: NMIN = NMIN + 1
     IF NSEC < 0 THEN NSEC = NSEC + 60: NMIN = NMIN - 1
1221 IF NMIN >= 60 THEN NMIN = NMIN - 60: LHOUR = LHOUR + 1: GOTO 1221
1222 IF NMIN < 0 THEN NMIN = NMIN + 60: LHOUR = LHOUR - 1: GOTO 1222
     LastDAY = 31
     IF (LMONTH = 4) OR (LMONTH = 6) THEN LastDAY = 30
     IF (LMONTH = 9) OR (LMONTH = 11) THEN LastDAY = 30
     IF LMONTH = 2 THEN LastDAY = 28
     IF (INT(LYEAR / 4) = (LYEAR / 4)) AND (LMONTH = 2) THEN LastDAY = 29
     IF LHOUR >= 24 THEN LHOUR = LHOUR - 24: LDAY = LDAY + 1
     IF LHOUR < 0 THEN LHOUR = LHOUR + 24: LDAY = LDAY - 1
     IF LDAY > LastDAY THEN LDAY = LDAY - LastDAY: LMONTH = LMONTH + 1
     LastDAY = 31
     IF ((LMONTH - 1) = 4) OR ((LMONTH - 1) = 6) THEN LastDAY = 30
     IF ((LMONTH - 1) = 9) OR ((LMONTH - 1) = 11) THEN LastDAY = 30
     IF (LMONTH - 1) = 2 THEN LastDAY = 28
     IF (INT(LYEAR / 4) = (LYEAR / 4)) AND ((LMONTH - 1) = 2) THEN LastDAY = 29
     IF LDAY < 1 THEN LDAY = LDAY + LastDAY: LMONTH = LMONTH - 1
     IF LMONTH > 12 THEN LMONTH = LMONTH - 12: LYEAR = LYEAR + 1
     IF LMONTH < 1 THEN LMONTH = LMONTH + 12: LYEAR = LYEAR - 1
     NMONTH = LMONTH
     NYEAR = LYEAR
     NDAY = LDAY
     NHOUR = LHOUR + DHOUR
     LastDAY = 31
     IF (NMONTH = 4) OR (NMONTH = 6) THEN LastDAY = 30
     IF (NMONTH = 9) OR (NMONTH = 11) THEN LastDAY = 30
     IF NMONTH = 2 THEN LastDAY = 28
     IF (INT(NYEAR / 4) = (NYEAR / 4)) AND (NMONTH = 2) THEN LastDAY = 29
     IF NHOUR >= 24 THEN NHOUR = NHOUR - 24: NDAY = NDAY + 1
     IF NHOUR < 0 THEN NHOUR = NHOUR + 24: NDAY = NDAY - 1
     IF NDAY > LastDAY THEN NDAY = NDAY - LastDAY: NMONTH = NMONTH + 1
     LastDAY = 31
     IF ((NMONTH - 1) = 4) OR ((NMONTH - 1) = 6) THEN LastDAY = 30
     IF ((NMONTH - 1) = 9) OR ((NMONTH - 1) = 11) THEN LastDAY = 30
     IF (NMONTH - 1) = 2 THEN LastDAY = 28
     IF (INT(NYEAR / 4) = (NYEAR / 4)) AND ((NMONTH - 1) = 2) THEN LastDAY = 29
     IF NDAY < 1 THEN NDAY = NDAY + LastDAY: NMONTH = NMONTH - 1
     IF NMONTH > 12 THEN NMONTH = NMONTH - 12: NYEAR = NYEAR + 1
     IF NMONTH < 1 THEN NMONTH = NMONTH + 12: NYEAR = NYEAR - 1
     year = NYEAR
     MONTH = NMONTH
     DAY = NDAY
     hour = NHOUR
     MIN = NMIN
     RETURN

9999 REM ********************************************************************
     REM *                                                                  *
     REM *  Print End of Program Information                                *
     REM *                                                                  *
     REM ********************************************************************
     SCREEN 0
     WIDTH 80, 25
     CLS : LOCATE 11, 1
     PRINT TAB(17); "                    Dan Bruton"
     PRINT TAB(17); "                  astro@sfasu.edu"
     PRINT TAB(17); "         Stephen F. Austin State University"
     PRINT TAB(17); "         Department of Physics and Astronomy"
     PRINT TAB(17); "                    October 1997"
     PRINT
     PRINT TAB(17); "     For updates and other astronomy software see"
     PRINT TAB(17); "    the software link at http://astro.phy.sfasu.edu/"
     PRINT : PRINT : PRINT : PRINT : PRINT : PRINT : PRINT : PRINT
     'FOR I = 1 TO 50000: NEXT I
     END
 
    REM *********************** END OF PROGRAM ***************************

